/* REXX Echo knife by Yuri V. Safronov (2:5020/204) */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
call ReadConfig

do Outs.idx=1 to Outs.0
  call TreatOutbound Outs.idx
end
/* call SysDropFuncs */
exit

ReadConfig:
    procedure expose Log Outs.

Log = '\fido\logs\knife.log'

Outs.0 = 2

Outs.1.in = '\fido\bink\out\'
Outs.1.hld = '\fido\bink\out\hold'
Outs.1.age = 10
Outs.1.size = 60000

Outs.2.in = '\fido\bink\out\139C00CC.PNT\'
Outs.2.hld = '\fido\bink\out\139C00CC.PNT\hold'
Outs.2.age = 7
Outs.2.size = 30000

return

TreatOutbound:
    procedure expose Outs. inpath hold maxage maxsize Log
idx = arg(1)
inpath = Outs.idx.in
hold = Outs.idx.hld
maxage = Outs.idx.age
maxsize = Outs.idx.size

/* Find hold directory and create if nessessary */
call SysFileTree hold,'tmpd','D'
if tmpd.0=0 then
  do
    cmd = 'md 'hold
    cmd
  end

call SysFileTree inpath'*.?LO','LOs','FO'
if LOs.0 = 0 then 
  return

/* Main loop */
do i=1 to LOs.0
  call TreatLO LOs.i
end
say 'End of processing 'inpath
Drop LOs.
return

TreatLO:
    procedure expose maxage maxsize inpath hold Log
name = arg(1)
Say "  Processing" name
templ = substr(name,1,lastpos('.',name))
call SysFileTree templ'BSY','BSYs','FO'
i = 1
files.0=0
if BSYs.0 = 0 then
  do
  /* Create BUSY flag */
    call CreateTrunc templ'BSY'
/*    rc=Stream(name,'c','open') */
    do forever
      str = linein(name)
      if str='' then leave
      sndtype = substr(str,1,1)
      if sndtype='^' | sndtype='#' | sndtype='~' then
        do
          files.i.t=sndtype
          files.i.n=substr(str,2)
        end
      else
        do
          files.i.t='*'
          files.i.n=str
        end
      if sndtype='#' then
        do
          if FileExist(files.i.n) = 'Y' then
            do
              files.i.age = FileAge(files.i.n)
              files.i.len = FileLen(files.i.n)
            end
          else
            do
              files.i.age = 0
              files.i.len = 0
              files.i.t = '~'
              rc=Stream(Log,'c','open')
              Call LineOut Log,'Error - cannot find 'files.i.n
              Call LineOut ,'      !!! Error'
              rc=Stream(Log,'c','close')
            end
        end
      else
        do
          files.i.age = 0
          files.i.len = 0
        end

    /* Treat large file */
      if files.i.t = '#' & files.i.len>maxsize then
        do
          newname = GetName(files.i.n,hold)
          if newname = 'FAULT' then
            say '     * cannot move' filespec('name',files.i.n) 'to hold - keeping'
          else
            do
              files.i.t = '^'
              say '     * moving' filespec('name',files.i.n) 'to 'newname
              '@copy' files.i.n newname '>nul'
              call SysFileDelete(files.i.n)
              call CreateTrunc files.i.n
              files.i.n = newname
            end
        end
      files.0=files.0+1
      i=i+1
    end

  /* Rewrite .?LO */
    call CharOut name,,1
    do i=1 to files.0
      if files.i.t='*' then
        call LineOut name,files.i.n
      else
        call LineOut name,files.i.t''files.i.n
    end
    call CharOut name

    call SysFileDelete templ'BSY' /* Kill Busy flag */
  end
else
  do
    say '  ****BUSY'
    return
  end

Drop files.
/* rc=Stream(name,'c','close') */
return

FileExist:
    procedure
name=arg(1)
call SysFileTree name, 'uuu', 'FO'
if uuu.0=0 then
  return 'N'
else
  return 'Y'

FileAge:
    procedure
name=arg(1)
call SysFileTree name, 'uuu', 'T'
filedate = substr(uuu.1, 1, 8)
return filedate

FileLen:
    procedure
name=arg(1)
call SysFileTree name, 'uuu', 'T'
return substr(uuu.1, 15, 12)+0

GetName:
    procedure
name=arg(1)
hold=arg(2)
name1=hold'\'filespec('name',name)
call SysFileTree name1, 'uuu', 'FO'
if uuu.0=0 then
    return name1
else
  do
    do i=c2d('0') to c2d('9')
      name1=Overlay(d2c(i),name1,Length(name1))
      call SysFileTree name1, 'uuu', 'FO'
      if uuu.0=0 then
          return name1
    end
    do i=c2d('a') to c2d('z')
      name1=Overlay(d2c(i),name1,Length(name1))
      call SysFileTree name1, 'uuu', 'FO'
      if uuu.0=0 then
          return name1
    end
  end
return 'FAULT'

CreateTrunc:
    procedure
  name = arg(1)
  call CharOut name,,1
  call CharOut name
return

