/* WatchDog session */
Call rxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
Call SysLoadFuncs

'@ECHO OFF'
/* trace all */
ESC    = '1B'x || "["   /* define ANSI-ESCape character */
black   = 0
red     = 1
green   = 2
yellow  = 3
blue    = 4
magenta = 5
cyan    = 6
white   = 7

/* ANSI-values for fore-/background */
foreground = 30         /* add color, e.g. 30 + 2 = 32 ==> green foreground */
background = 40         /* add color, e.g. 40 + 7 = 47 ==> white background */

/* additional ANSI-values which work on VGA */
normal    = 0           /* reset screen to white on black */
bold      = 1
/************************** end of ANSI-information **************************/



/*******************************************************/
/* default settings for WHITE TEXT on BLACK BACKGROUND */
/*******************************************************/

screen_normal  = normal || ";" || foreground + white  || ";" || background + black
screen_inverse = normal || ";" || foreground + black  || ";" || background + white
text_normal    = screen_normal
text_info      = screen_normal || ";" ||                foreground + cyan
text_highlight = screen_normal || ";" ||                foreground + yellow
text_alarm     = screen_normal || ";" || bold || ";" || foreground + red
/* inverse colors */
text_normal_inverse    = screen_inverse
text_info_inverse      = screen_inverse || ";" ||                foreground + cyan
text_highlight_inverse = screen_inverse || ";" ||                foreground + green
text_alarm_inverse     = screen_inverse || ";" || bold || ";" || foreground + red
screen_normal      = ESC || screen_normal       || "m"
screen_inverse     = ESC || screen_inverse      || "m"
text_normal        = ESC || text_normal         || "m"
text_info          = ESC || text_info           || "m"
text_highlight     = ESC || text_highlight      || "m"
text_alarm         = ESC || text_alarm          || "m"
text_normal_inverse    = ESC || text_normal_inverse     || "m"
text_info_inverse      = ESC || text_info_inverse       || "m"
text_highlight_inverse = ESC || text_highlight_inverse  || "m"
text_alarm_inverse     = ESC || text_alarm_inverse      || "m"
/*******************************************************/

/*************************** Start watchdog *********************/
Call AllBsy
CurrDate=Date()
Call SysCls
CALL CHAROUT ,screen_normal          /* set screen */

do forever
  Call SysSleep 30
  'cd \fido\bink\flag'
/*** Check for tasks is alive ***/
  Call SysFileTree '\fido\bink\flag\task.*','TSKs','FO'
  if TSKs.0 > 0 then
    do i=1 to TSKs.0
      Select
        When filespec('Name',TSKs.i) == 'Task.tos' then  /* Treat tosser */
          do
            Call SysFileTree TSKs.i,tmp ,'T'
          
            if tmp.0<>0 then
              do
                if DATE('O') = SUBSTR(tmp.1,1,8) then
                  add = 0
                else
                  add = 84600
                ft = (SUBSTR(tmp.1,10,2) * 60 + SUBSTR(tmp.1,13,2)) * 60
                age = time('S') - ft + add
                if age > 4800 then       /* Restart tosser */
                  do
                    Call KillSes 'Tosser'
                    'start "Tosser" /b/fs/c Tosser.cmd'
                    Call SayKill "T", age
                  end
              end
          end
	  When filespec('Name',TSKs.i) == 'Task.01' then  /* Treat bink1 */
	    do
	      'c:\drv\sio\su.exe 1 dcd >nul'
	      if rc == 0 then             /* DCD off */
	        do
	          call SysSleep 10      /* add delay for Bink remove Task.* */
	          if FileExist(TSKs.i) then /* kill it out */
	            do
                  Call SysSleep 1
        	      'c:\drv\sio\su.exe 1 dcd >nul'
                  if rc == 0 then
                    do
                      'go.exe k BT32 > nul 2> nul'
                      Call SayKill "1"
                      'del d:\fido\files\*.r01 >nul 2>nul'
                      'del d:\fido\files\known\*.r01 >nul 2>nul'
                      'del d:\fido\files\prot\*.r01 >nul 2>nul'
                      Call AllBsy
                    end
	            end
	        end
	    end
	  When filespec('Name',TSKs.i) == 'Task.02' then  /* Treat bink1 */
	    do
	      'c:\drv\sio\su.exe 2 dcd >nul'
	      if rc == 0 then             /* DCD off */
	        do
	          call SysSleep 10      /* add delay for Bink remove Task.* */
	          if FileExist(TSKs.i) then /* kill it out */
	            do
        	       call SysSleep 1
            	   'c:\drv\sio\su.exe 2 dcd >nul'
                   if rc == 0 then
                     do
                       'go.exe k BT2 > nul 2> nul'
                       Call SayKill "2"
                       'del d:\fido\files\*.r02 >nul 2>nul'
                       'del d:\fido\files\known\*.r02 >nul 2>nul'
                       'del d:\fido\files\prot\*.r02 >nul 2>nul'
                       Call AllBsy
                     end
	            end
	        end
	    end
      end
    end

  Flg = 0
  if FileExist('task.01') then Flg=Flg+1
  if FileExist('task.02') then Flg=Flg+2
  if FileExist('tossing.now') then CALL CHAROUT ,text_alarm
                                  else CALL CHAROUT ,screen_normal
  Select
    when Flg = 0 then symb=''
    when Flg = 1 then symb=''
    when Flg = 2 then symb=''
    when Flg = 3 then symb=''
  end
  Call CharOut ,symb

  if CurrDate<>Date() & Flg=0 then
    do
      'cd \fido\bink'
      Call KillSes 'Line1'
      Call KillSes 'Line2'
      'go.exe k bt32 > nul 2> nul'
      'go.exe k bt2 > nul 2> nul'
      'del ID.tmp'
      Call SysSleep 10 /* for stopping bt32 sessions */
      'move \fido\logs\*.log \fido\logs\arc >nul'
      'start /c/b/fs treatlog.cmd'
      Call BinkBoth.cmd
      Currdate=Date()
    end
end

KillSes:
    procedure
Name=arg(1)
rc=Directory('\fido\bink')
'nolist.exe /L' Name '> ID.TMP 2> nul'
str = linein('ID.tmp')
Parse value str with tmp '['ID']'
'terminat.exe ' d2x(ID) ' >nul 2> nul'
rc = STREAM("ID.tmp", "C", "CLOSE")
return

FileExist:
    procedure
  name=arg(1)
  call SysFileTree name, 'uuu', 'FO'
  if uuu.0=0 then    return 0
  else               return 1

AllBsy:
  Call DelBsy '\fido\bink'
  Call DelBsy '\fido\bink\out'
return

DelBsy:
procedure
  Parse arg root
  call SysFileTree root'\*.*','tmpd','DO'
  do i=1 to tmpd.0
    cmd ='del' tmpd.i'\*.BSY >nul 2>nul'
    cmd
  end
return

SayKill:
procedure
  tsk = arg(1);
/*  age = arg(2); */
  rc = CharOut(,"");
  rc = CharOut(, tsk);
/*  rc = CharOut(," -" age); */
  rc = CharOut(,"");
return
